/*for half moon version*/
/*rainbow light*/
/*for 1.0 board*/

#include <avr/sleep.h>
#include <Adafruit_NeoPixel.h>
#include <avr/power.h>
#include "PinChangeInterrupt.h"

#define LDR 2     //PIR 1 interrupt pin -> for photoresistor detection in this version
#define PIR_2 5
#define PIR_3 7   //not used
#define PIN 6       // led strip in
#define CONVERTER 3 //converter enable pin
#define RELAY 4     //relay nais command pin
#define TEMPO 20000 //time to let the strip on
#define DEBUG false
#define VERBOSE false


Adafruit_NeoPixel strip = Adafruit_NeoPixel(22, PIN, NEO_GRB + NEO_KHZ800);
volatile byte pir_nb; //which pir has triggered ?

void setup() {
  Serial.begin(9600);
  pinMode(LDR, INPUT);
  pinMode(PIR_2, INPUT);
  //pinMode(PIR_3, INPUT);
  pinMode(CONVERTER,OUTPUT);
  pinMode(RELAY,OUTPUT);

  if (DEBUG) Serial.println("started");
  
  strip.begin();
  strip.setBrightness(25); //special to limit light with the rainbow function
  strip.show();

  digitalWrite(CONVERTER,HIGH); //enable boost converter, in this version the booster converter is always ON

  //say hello
  digitalWrite(RELAY,HIGH); //connect led strip
  for (int i=0;i<2;i++)
  {
    colorWipe(strip.Color(45,20,35),12);
    delay(500);
    colorWipe(strip.Color(0,0,0),12);
    delay(500);
  }
  strip_off();

  noInterrupts();
  //attachPCINT(digitalPinToPCINT(LDR),wakeUp_1,RISING);
  attachPCINT(digitalPinToPCINT(PIR_2),wakeUp_2,RISING);
  //attachPCINT(digitalPinToPCINT(PIR_3),wakeUp_3,RISING);
}

void loop() {
  pir_nb=0; 
  if (DEBUG) { Serial.println("going to sleep.."); delay(1500);}
  Going_To_Sleep(); //set interrupt enable
 
  //the interrupt wakes up the uC but at this point
  if (DEBUG) Serial.println("is awaken..");
  if (digitalRead(LDR)==HIGH)
  {
     if (DEBUG) Serial.println("LDR is HIGH (dark room)");
     if (pir_nb!=0) 
   {
      detachPCINT(digitalPinToPCINT(PIR_2)); //cli() does not work here
      //detachPCINT(digitalPinToPCINT(PIR_3)); //because of strip library
      strip_on();
       strip_off();
      attachPCINT(digitalPinToPCINT(PIR_2),wakeUp_2,RISING);
      //attachPCINT(digitalPinToPCINT(PIR_3),wakeUp_3,RISING);
    }
  }
}

void Going_To_Sleep()
{
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
  sleep_enable();
  interrupts();
  sleep_cpu();  
}

void wakeUp_1()
{
  pir_nb=1;
  if (DEBUG) 
  {
    blynk(1);
  }
}

void wakeUp_2()
{
  pir_nb=2;
  if (DEBUG) 
  {
    blynk(2);
  }
}

void wakeUp_3()
{
  pir_nb=3;
  if (DEBUG) 
  {
    blynk(3);
  }
 }

void blynk(int a)
{
  for (int i=0;i<a;i++)
  {
    digitalWrite(13,HIGH);
    for (long j=0;j<500000;j++) {__asm__("nop\n\t");}
    digitalWrite(13,LOW);
    for (long j=0;j<500000;j++) {__asm__("nop\n\t");};
  }
}
